#!/bin/sh
# activate.sh - calls DesignBuilder web server to obtain activated .lic file for the license server
# script version 1.0
#

hostname=`hostname`
hostname=$( printf "%s\n" "$hostname" | sed 's/ //g' )

ipaddr=`hostname -I`
ipaddr=$( printf "%s\n" "$ipaddr" | sed 's/ //g' )

hostid=`./rlmutil rlmhostid -q`
hostid=$( printf "%s\n" "$hostid" | sed 's/ $//g' )

token=$1
token=$( printf "%s\n" "$token" | sed 's/ //g' )

if [ "$1" = "-h" ]
then
	echo "Hostid: " $hostid
	echo "hostname: " $hostname
	echo "IP Addr: " $ipaddr
	exit 0
fi

length=8
while test -z "$token" -o $length -ne 8
do
	echo -n "Enter your 8 digit activation code: "
	read token
	token=$( printf "%s\n" "$token" | sed 's/ //g' )
  	num=`echo "${token}" | wc -c`
  	length=`expr $num - 1`
	#echo $length
done

#echo $hostname $ipaddr $hostid $token


# call wget to pull down the activation info
url="http://www.designbuilder.co.uk/license/activate3s.php?token=$token&hostname=$hostname&ipaddr=$ipaddr&hostid=$hostid"
url=$( printf "%s\n" "$url" | sed 's/ /%20/g' )
rm -f activate3s.php*
wget -q "$url" 
f1="httpresponse1.txt"
f2="httpresponse2.txt"
mv activate3s.php* $f1 > /dev/null 2>&1
if [ $? -ne 0 ]
then
	echo
	echo "SORRY: No internet connection or no connection to Designbuilder web server"
	echo
	echo "Please check the README.TXT file for manual activation instuctions"
	echo
	echo "Hostid: " $hostid
	echo "hostname: " $hostname
	echo "IP Addr: " $ipaddr
	exit 1
fi

result=`grep "successful" $f1`
if [ $? -eq 0 ]
then
	rm -f download_license.php*
	wget -q "http://www.designbuilder.co.uk/license/download_license.php?token=$token"
	mv download_license.php* $f2
	
	result=`grep "ISV designb" $f2`
	if [ $? -eq 0 ]
	then
		rm -f $token.lic
		mv $f2 $token.lic
		echo "Successfully obtained $token.lic now move it into the license server installation directory"
		exit 0
	else
		echo
		echo "SORRY downloading the license file has failed"
		echo "Try again but it it continues to fail please check README.TXT"
		echo "for manual activation instructions or contact Designbuilder support"

		exit 1
	fi
fi

result=`grep -i "SORRY" $f1`
if [ $? -eq 0 ]
then
	result=$( printf "%s\n" "$result" | sed 's/<h2>//g' )
	result=$( printf "%s\n" "$result" | sed 's:</h2>::g' )
	echo
	echo $result
	
	errtype=`grep -i "already in use" $f1`
	if [ $? -eq 0 ]
	then
		echo 
		echo "If you are moving the license server to a new computer"
		echo "please contact Designbuilder support and let us know your activation code"
		echo "We can deactivate the previous installation and allow you to re-activate"
		echo
		exit 1
	fi

	errtype=`grep -i "recognised" $f1`
	if [ $? -eq 0 ]
	then
		echo 
		echo "Please check your activation code and make sure it is entered correctly"
		echo
		exit 1
	fi

	exit 1
fi

# should never get here
echo
echo "SORRY - unknown response from Designbuilder web server"
echo "Please refer to README.TXT for manual installation instructions"
echo

exit 0


